# Interface methods for submodule: LBFGSOptimizer
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate
from ._proxies import SingleValuedNonLinearVnlOptimizerProxy as _SingleValuedNonLinearVnlOptimizerProxy


# Interface methods for class: LBFGSOptimizer
class LBFGSOptimizerProxy(_SingleValuedNonLinearVnlOptimizerProxy):
	@staticmethod
	def New():
		""""""
		...

	def Clone(self):
		""""""
		...

	def GetNameOfClass(self):
		""""""
		...

	def GetOptimizer(self):
		""""""
		...

	def StartOptimization(self) -> None:
		""""""
		...

	def SetCostFunction(self, costFunction) -> None:
		""""""
		...

	def SetTrace(self, flag: bool) -> None:
		""""""
		...

	def GetTrace(self) -> bool:
		""""""
		...

	def TraceOn(self) -> None:
		""""""
		...

	def TraceOff(self) -> None:
		""""""
		...

	def SetMaximumNumberOfFunctionEvaluations(self, n: int) -> None:
		""""""
		...

	def GetMaximumNumberOfFunctionEvaluations(self) -> int:
		""""""
		...

	def SetGradientConvergenceTolerance(self, f: float) -> None:
		""""""
		...

	def GetGradientConvergenceTolerance(self) -> float:
		""""""
		...

	def SetLineSearchAccuracy(self, f: float) -> None:
		""""""
		...

	def GetLineSearchAccuracy(self) -> float:
		""""""
		...

	def SetDefaultStepLength(self, f: float) -> None:
		""""""
		...

	def GetDefaultStepLength(self) -> float:
		""""""
		...

	def GetValue(self) -> float:
		""""""
		...

	def GetStopConditionDescription(self) -> str:
		""""""
		...

